﻿using System;
using System.Text;
using System.Collections;

namespace Iterators
{
	public class MyListOld : IEnumerable
	{
		private int[] vals = { 1, 2, 3 };

		private class MyEnumerator : IEnumerator
		{
			private MyListOld hostObj;
			private int index = -1;

			public MyEnumerator(MyListOld host)
			{
				hostObj = host;
			}

			public object Current
			{
				get { return hostObj.vals[index]; }
			}

			public void Reset()
			{
				index = -1;
			}

			public bool MoveNext()
			{
				bool result = false;
				if (index < hostObj.vals.Length - 1)
				{
					index++;
					result = true;
				}

				return result;
			}
		}

		public IEnumerator GetEnumerator()
		{
			return new MyEnumerator(this);
		}
	}

	class MyList
	{
		private int[] vals = { 1, 2, 3 };

		public IEnumerator GetEnumerator()
		{
			foreach (int i in vals)
			{
				yield return i;
			}
		}
	}
}
