﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion

namespace ReflectionGenericsExample
{
	class Program
	{
		static void Main(string[] args)
		{
			MyList<int> intList = new MyList<int>();
			MyList<double> doubleList = new MyList<double>();

			exploreType(intList);
			exploreType(doubleList);

			Console.ReadLine();
		}

		public static void exploreType(object obj)
		{
			Console.WriteLine("**********************");
			Type theType = obj.GetType();
			Console.WriteLine("Type is " + theType.FullName);

			Console.WriteLine("Is it a generic class?:" + theType.IsGenericTypeDefinition);
			Console.WriteLine("Has Generic Arguments?" + theType.HasGenericArguments);
			Console.WriteLine("Generic Type arguments are:");
			foreach (Type anArg in theType.GetGenericArguments())
			{
				Console.WriteLine(anArg.FullName);
			}

			Type theGenericTypeForType = theType.GetGenericTypeDefinition();

			if (theGenericTypeForType != null)
			{
				Console.WriteLine("The generic type from which instantiated:" +
					theGenericTypeForType.FullName);
				Console.WriteLine("Is it a generic class?:" + theGenericTypeForType.IsGenericTypeDefinition);
				Console.WriteLine("Has Generic Arguments?" + theGenericTypeForType.HasGenericArguments);
			}
		}
	}
}
